/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: smrslv2txt.c,v 1.1 2005/12/07 00:38:41 ca Exp $")

#include "sm/error.h"
#include "sm/smar.h"

/*
**  SM_RSLV2TXT -- convert reverse lookup result to textual description
**
**	Parameters:
**		rslv -- reverse lookup result
**
**	Returns:
**		textual description of flags
*/

const char *
sm_rslv2txt(sm_ret_T rslv)
{
	switch (rslv)
	{
	  case SM_RVRS_MATCH:
		return "ok";
	  case SM_RVRS_NOMATCH:
		return "no";
	  case SM_RVRS_TEMP_PTR:
		return "tempptr";
	  case SM_RVRS_TEMP_A:
		return "tempa";
	  default:
		/* SM_ASSERT(false); ??? */
		return "bogus";
	}
}

